<?php
//extend forum
add_filter('bp_get_the_topic_post_content', 'bp_code_snippets_add_forum_snippet_content', 5);
add_filter('bp_get_the_topic_post_content', 'bp_code_snippets_forum_highlight', 6);
add_action('groups_forum_new_topic_after', 'bp_code_snippets_forum_button');
add_action('bp_after_group_forum_post_new', 'bp_code_snippets_forum_button');
add_action('bp_group_after_edit_forum_topic', 'bp_code_snippets_forum_button');
add_action('groups_forum_new_reply_after','bp_code_snippets_forum_button_reply');
add_action('bp_group_after_edit_forum_post','bp_code_snippets_forum_button_edit_post');


function bp_code_snippets_forum_button(){
	$url = BP_CS_PLUGIN_URL.'/bp-cs-snippet-selector.php?type=forum&tab=add&TB_iframe=true&amp;height=500&amp;width=640';
	?>
	<div style="margin:4px">
		<a href="<?php echo $url;?>" class="thickbox button" title="<?php _e('Add Snippet','bp-code-snippets');?>"><?php _e('Add Snippet','bp-code-snippets');?></a>
	</div>
	<?php
}

function bp_code_snippets_forum_button_reply(){
	$url = BP_CS_PLUGIN_URL.'/bp-cs-snippet-selector.php?type=forum-reply&tab=add&TB_iframe=true&amp;height=500&amp;width=640';
	?>
	<div style="margin:4px">
		<a href="<?php echo $url;?>" class="thickbox button" title="<?php _e('Add Snippet','bp-code-snippets');?>"><?php _e('Add Snippet','bp-code-snippets');?></a>
	</div>
	<?php
}

function bp_code_snippets_forum_button_edit_post(){
	$url = BP_CS_PLUGIN_URL.'/bp-cs-snippet-selector.php?type=edit-post&tab=add&TB_iframe=true&amp;height=500&amp;width=640';
	?>
	<div style="margin:4px">
		<a href="<?php echo $url;?>" class="thickbox button" title="<?php _e('Add Snippet','bp-code-snippets');?>"><?php _e('Add Snippet','bp-code-snippets');?></a>
	</div>
	<?php
}

function bp_code_snippets_add_forum_snippet_content($text){
	$array_type_snippet=array();
	preg_match_all("/\[snippet id\=\"([0-9]+)/", $text, $matches, PREG_SET_ORDER);
	if($matches){
		
		foreach($matches as $snippet){
			$type_snippet = bp_code_snippets_single_code($snippet[1],0);
			$text= preg_replace("/\[snippet id\=\"(".$snippet[1]."+)\"\]/", bp_code_snippets_shortcode_forum_handler($snippet[1]), $text);
			if(!in_array($type_snippet, $array_type_snippet)){
				$array_type_snippet[]=$type_snippet;
			}
		}
		$content_before="";
		foreach($array_type_snippet as $type){
			$content_before.= "<script type='text/javascript' src='".BP_CS_PLUGIN_URL."/js/highlighter/".bp_code_snippets_load_post_js($type).".js'></script>";
		}
		$content_after ='<script type="text/javascript">SyntaxHighlighter.all()</script>';
		return $content_before.$text.$content_after;
	}
	else return $text;
}


function bp_code_snippets_shortcode_forum_handler($id) {
	$siteurl = get_blog_option('1', 'siteurl');
	$snippet = bp_code_snippets_single_code($id,1);
	$user_info = get_userdata($snippet->id_user);
	$group_info = bp_code_snippet_get_infos_goup($snippet->id_group);
	$snippet_permalink = '<a href="'.$siteurl.'/'.BP_GROUPS_SLUG.'/'.$group_info->slug.'/'.BP_CS_SLUG.'/single/'.$snippet->id_cs.'/" title="'. sprintf( __( 'See it in %s group ', 'bp-code-snippets'), $group_info->name ) .'">'.$group_info->name.'</a>';
		
	$snippet_content = '<a name="snippet_'.$id.'"></a><div class="code_in_content"><pre class="brush: '.$snippet->snippet_type.'">'.stripslashes($snippet->snippet_content).'</pre></div>';
	$snippet_content .='<div class="snippet_author">'.__('Originally posted by', 'bp-code-snippets').' <a href="'.$siteurl.'/'.BP_MEMBERS_SLUG.'/'.$user_info->user_nicename.'" title="'.$user_info->user_nicename.'" rel="nofollow">'.$user_info->user_nicename.'</a><i>'.sprintf( __( ' in %s group', 'bp-code-snippets' ), $snippet_permalink ).'</i></div>';
	return $snippet_content;
}

function bp_code_snippets_forum_highlight($forum_topic, $action=""){
	$array_type_snippet=array();
	preg_match_all('#\`pre type=\"[a-z0-9._-]+\"\`(.*)\`\/pre\`#sU', $forum_topic, $matches);
	if($matches){
		$replacement=array();
		$highlight_topic="";
		for($i=0; $i<count($matches[0]);$i++){
			preg_match('#\`pre type=\"(.*)\"\`#sU', $matches[0][$i], $type);
			$replacement[]=array("type"=>$type[1], "snippet"=>$matches[1][$i]);
		}
		foreach($replacement as $limit_type){
			$type_snippet = $limit_type['type'];
			if(!in_array($type_snippet, $array_type_snippet)){
				$array_type_snippet[]=$type_snippet;
			}
		}
		$comment = preg_split('#\`pre type=\"[a-z0-9._-]+\"\`(.*)\`\/pre\`#sU', $forum_topic);
		if(count($comment)<count($replacement)){
			$length = count($replacement);
		}
		else{
			$length = count($comment);
		}
		for($i=0;$i<$length;$i++){
			if(@$comment[$i]) $highlight_topic.= @$comment[$i];
			if($action!=""){
				if(@$replacement[$i]) $highlight_topic.= "\n".'<a href="'.$action.'">'.sprintf( __( 'Open the %s Snippet', 'bp-code-snippets'), @$replacement[$i]['type'] ).'</a>'."\n";
			}else{
				if(@$replacement[$i]) $highlight_topic.= "\n".'<pre class="brush: '.@$replacement[$i]['type'].'">'.@$replacement[$i]['snippet'].'</pre>'."\n";
			}
		}
		$content_before="";
		foreach($array_type_snippet as $type){
			$content_before.= "<script type='text/javascript' src='".BP_CS_PLUGIN_URL."/js/highlighter/".bp_code_snippets_load_post_js($type).".js'></script>";
		}
		$content_after ='<script type="text/javascript">SyntaxHighlighter.all()</script>';
		if($action!="") return $highlight_topic;
		else return $content_before.$highlight_topic.$content_after;
	}
	else return $forum_topic;
}
?>