<?php

/**
 * bp_snippets_manager_admin()
 *
 * Checks for form submission, saves component settings and outputs admin screen HTML.
 */
function bp_snippets_manager_admin() {
	global $bp;
	if ( isset( $_POST['save'] ) && check_admin_referer('cs-settings') ) {
		update_option( 'cs-setting-theme', $_POST['cs-theme'] );
		update_option( 'cs-enable', $_POST['cs-enable'] );
		update_option( 'cs-ma-enable', $_POST['cs-ma-enable'] );
		update_option( 'cs-homenav-enable', $_POST['cs-homenav-enable'] );
		update_option( 'cs-ep-enable', $_POST['cs-ep-enable'] );
		update_option( 'cs-ef-enable', $_POST['cs-ef-enable'] );

		$updated = true;
	}

	$setting_theme = get_option( 'cs-setting-theme' );
	$cs_enable = get_option( 'cs-enable' );
	$cs_ma_enable = get_option( 'cs-ma-enable' );
	$cs_homenav_enable = get_option( 'cs-homenav-enable' );
	$cs_ep_enable = get_option( 'cs-ep-enable' );
	$cs_ef_enable = get_option( 'cs-ef-enable' );
	$list_cs_theme = array();
	$cs_theme_directory = BP_CS_PLUGIN_DIR .'/css/theme/';
	$dir_handle = @opendir($cs_theme_directory) or die("Unable to open $path");
	while ($file = readdir($dir_handle)) {
		$name = explode(".",$file);
		if($name[1]=="css") {
				$list_cs_theme[]=array('value'=>$file, 'label'=>$name[0]);
		}
	}
?>
	<div class="wrap">
		<h2><?php _e( 'Code Snippets Manager', 'bp-code-snippets' ) ?></h2>
		<br />

		<?php if ( isset($updated) ) : ?><?php echo "<div id='message' class='updated fade'><p>" . __( 'Settings Updated.', 'bp-code-snippets' ) . "</p></div>" ?><?php endif; ?>
			

		<form action="" name="bp-cs-settings-form" id="bp-cs-settings-form" method="post">

			<table class="form-table">
				<tr valign="top">
					<th scope="row"><label for="cs-enable"><?php _e( 'Enable Code Snippets for Groups', 'bp-code-snippets' ) ?></label></th>
					<td>
						<input type="radio" name="cs-enable" id="cs-enable-yes" value="1" <?php if($cs_enable) echo "checked";?>/><?php _e( 'Yes', 'bp-code-snippets' ) ?>&nbsp;
						<input type="radio" name="cs-enable" id="cs-enable-no" value="0" <?php if(!$cs_enable) echo "checked";?>/><?php _e( 'No', 'bp-code-snippets' ) ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="cs-homenav-enable"><?php _e( 'Add Snippets to BuddyPess main navigation', 'bp-code-snippets' ) ?></label></th>
					<td>
						<input type="radio" name="cs-homenav-enable" id="cs-homenav-enable-yes" value="1" <?php if($cs_homenav_enable) echo "checked";?>/><?php _e( 'Yes', 'bp-code-snippets' ) ?>&nbsp;
						<input type="radio" name="cs-homenav-enable" id="cs-homenav-enable-no" value="0" <?php if(!$cs_homenav_enable) echo "checked";?>/><?php _e( 'No', 'bp-code-snippets' ) ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="cs-ma-enable"><?php _e( 'Display item My Snippets in Member Area', 'bp-code-snippets' ) ?></label></th>
					<td>
						<input type="radio" name="cs-ma-enable" id="cs-ma-enable-yes" value="1" <?php if($cs_ma_enable) echo "checked";?>/><?php _e( 'Yes', 'bp-code-snippets' ) ?>&nbsp;
						<input type="radio" name="cs-ma-enable" id="cs-ma-enable-no" value="0" <?php if(!$cs_ma_enable) echo "checked";?>/><?php _e( 'No', 'bp-code-snippets' ) ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="cs-ep-enable"><?php _e( 'Enable Snippets embeding in blogs posts', 'bp-code-snippets' ) ?></label></th>
					<td>
						<input type="radio" name="cs-ep-enable" id="cs-ep-enable-yes" value="1" <?php if($cs_ep_enable) echo "checked";?>/><?php _e( 'Yes', 'bp-code-snippets' ) ?>&nbsp;
						<input type="radio" name="cs-ep-enable" id="cs-ep-enable-no" value="0" <?php if(!$cs_ep_enable) echo "checked";?>/><?php _e( 'No', 'bp-code-snippets' ) ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="cs-ef-enable"><?php _e( 'Enable Snippets embeding in forums posts', 'bp-code-snippets' ) ?></label></th>
					<td>
						<input type="radio" name="cs-ef-enable" id="cs-ef-enable-yes" value="1" <?php if($cs_ef_enable) echo "checked";?>/><?php _e( 'Yes', 'bp-code-snippets' ) ?>&nbsp;
						<input type="radio" name="cs-ef-enable" id="cs-ef-enable-no" value="0" <?php if(!$cs_ef_enable) echo "checked";?>/><?php _e( 'No', 'bp-code-snippets' ) ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="cs-theme"><?php _e( 'Highlighter Theme', 'bp-code-snippets' ) ?></label></th>
					<td>
						<select name="cs-theme" id="cs-theme">
							<?php foreach($list_cs_theme as $theme):?>
								<?php if($setting_theme == $theme['value']):?>
									<option value="<?php echo $theme['value'];?>" selected><?php echo $theme['label'];?></option>
								<?php else:?>
								<option value="<?php echo $theme['value'];?>"><?php echo $theme['label'];?></option>
									<?php endif;?>
							<?php endforeach;?>
						</select>
					</td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" name="save" value="<?php _e( 'Save Settings', 'bp-code-snippets' ) ?>"/>
			</p>

			<?php
			/* This is very important, don't leave it out. */
			wp_nonce_field( 'cs-settings' );
			?>
		</form>
	</div>
<?php
}
?>